
/* ##############################################################
	설  명 : [Modal]조직 상세/수정 팝업
	작성일 : 2023. 01. 19.
	작성자 : NTsoft
	수정일 	        수정자 	 수정내용
	-------         -------- ---------------------------
	2023. 01. 19.	NTsoft 	 최초 생성
*/
let groupUpdateModal = {
	callback : null,
	reqParam : null,
	dataList : null,
	/* 모달 초기화 작업 */
	init : function () {
		$('#groupUpdateModal').remove();
		$('body').append( this.HtmlTemplate);
		//그리드 이벤트
		this.setEvent();
	},
	/* 그리드 이벤트 설정 */
	setEvent:function() {
		$('#groupUpdateModal .btnCancle').on("click", function(){
			groupUpdateModal.close();
		});

		$('#groupUpdateModal .btnSave').on("click", function(){
			groupUpdateModal.save("I");
		});

        $('#groupUpdateModal #modalorderNumber').on('input', function() {
            // 입력된 키가 숫자가 아닌 경우 입력을 막음
            this.value = this.value.replace(/\D/g, '');
        });
	},
	/* 데이터 선택 */
	setSelect:function(selectNumber) {
		let checkedData = dataList[selectNumber];
		if(dataList==null||checkedData==undefined){
			return ;
		}

		if( groupUpdateModal.callback )  {
			groupUpdateModal.callback(checkedData);
		}
		groupUpdateModal.close();
	},
	// 상세 조회
	search:function(state) {
		let muGroupId = groupUpdateModal.reqParam.muGroupId;

		if(true != fn_emptyCheck(muGroupId)){
			modalEvent.warning("수정", "조직 정보가 없습니다.");
			return;
		}

		let formData = new FormData();
		formData.append("menuClass", menuClass);
		formData.append("muGroupId", muGroupId);

		$.ajax({
			url: encodeURI('/webgroup/selectGroup.do'),
			data: formData,
			dataType: "json",
			processData: false,
			contentType: false,
			type: 'POST',
			async: true,
			success: function(data){
				if('0'==data.msgCode){
					$("#groupUpdateModal #modalorderNumber").val(data.rows[0].orderNumber)
					$("#groupUpdateModal #modalGroupName").val(data.rows[0].groupName);
					$("#groupUpdateModal #modalEtc").val(data.rows[0].etc);
				}
				else{
					modalEvent.danger("조회 오류", data.msgDesc);
				}
			},
			error : function(xhr, status, error) {
				modalEvent.danger("조회 오류", "조회 중 오류가 발생하였습니다. 잠시후 다시시도하십시오.");
			},
			beforeSend:function(){

			},
			complete:function(){

			}
		});
	},
	//저장
	save:function(state) {
		let muGroupId     = groupUpdateModal.reqParam.muGroupId;
		let orderNumber     = $("#groupUpdateModal #modalorderNumber").val();
		let groupName     = $("#groupUpdateModal #modalGroupName").val();
		let etc           = $("#groupUpdateModal #modalEtc").val();

		if(true != fn_emptyCheck(groupName)){
			modalEvent.warning("수정", "조직명 정보가 없습니다.");
			return;
		}
		else{
			if(true != fn_lengthCheck(groupName, 35)) {
				modalEvent.warning("수정", "조직명 정보는 35자를 넘을 수 없습니다.");
				return;
			}
		}
		if(true != fn_emptyCheck(orderNumber)){
			modalEvent.warning("수정", "정렬 순서가 없습니다.");
			return;
		}
		modalEvent.info("수정", "조직 정보를 수정하시겠습니까?", function(){
			let formData = new FormData();
			formData.append("menuClass", menuClass);
			formData.append("muGroupId", muGroupId);
			formData.append("orderNumber", orderNumber);
			formData.append("groupName", groupName);
			formData.append("etc", etc);

			$.ajax({
				url: encodeURI('/webgroup/updateGroup.do'),
				data: formData,
				dataType: "json",
				processData: false,
				contentType: false,
				type: 'POST',
				async: true,
				success: function(data){
					if('0'==data.msgCode){
						modalEvent.success("수정 성공", data.msgDesc, function(){
							if( groupUpdateModal.callback )  {
								groupUpdateModal.callback();
							}
							groupUpdateModal.close();
						});
					}
					else{
						modalEvent.danger("수정 오류", data.msgDesc);
					}
				},
				error : function(xhr, status, error) {
					modalEvent.danger("수정 오류", "등록 중 오류가 발생하였습니다. 잠시후 다시시도하십시오.");
				},
				beforeSend:function(){

				},
				complete:function(){

				}
			});
		});
	},
	/*
	 * 팝업
	 * callback : 콜백함수, reqParam: 팝업파라미터
	 */
	popup:function(callback, reqParam) {
		// 초기화 후 열기
		groupUpdateModal.init();

		//콜백함수 지정.
		groupUpdateModal.callback = callback;
		groupUpdateModal.reqParam = reqParam;
		groupUpdateModal.dataList = null;

		groupUpdateModal.search();

		setTimeout(function(){
			$('#groupUpdateModal').modal('show')
		}, 200);
	},
	/*
	 * 팝업 닫기
	 */
	close:function() {
		$('#groupUpdateModal').modal('hide');

		setTimeout(function(){
			$('#groupUpdateModal').remove();
		},500);
	},
	HtmlTemplate : `
	<div id="groupUpdateModal" class="modal group_information_correction_modal fade" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="">
		<div class="modal-dialog">
			<div class="modal-content">
				<div class="modal-header">
					<p class="title">조직 정보 수정</p>
				</div>
	
				<div class="modal-body">
					<div class="form_box">
						<div class="input_box">
							<label>조직 명</label>
							<input type="text" id="modalGroupName" placeholder="조직 명" maxlength="35">
						</div>
						<div class="input_box">
							<label>정렬 순서</label>
							<input type="number" id="modalorderNumber" placeholder="0" maxlength="35">
						</div>
						<div class="textarea_box">
							<label>메모</label>
							<textarea id="modalEtc" placeholder="메모를 입력해주세요."></textarea>
						</div>
					</div>
				</div>

				<div class="modal-footer">
					<div class="btn_box">
						<button type="button" class="cancel_btn btnCancle">취소</button>
						<button type="button" class="save_bth btnSave">수정</button>
					</div>
				</div>
			</div>
		</div>
	</div>
    `
};
